;SAVE1500 Sends .P files to a TS1500 or ZX81 through the PC parallel port.'
;(C) 1998 Luis C. Grosso.

CSEG            SEGMENT
                ASSUME CS:CSEG,DS:CSEG
                ORG 100H
PRINCIPIO:      JMP BEGIN

ESENTER:        JMP ESENTERJ            ;print brief help
ESUNO:          JMP ESUNOJ              ;set 03BCH
ESDOS:          JMP ESDOSJ              ;set 0378H
ESTRES:         JMP ESTRESJ             ;set 0278H
NOPARM:         JMP NOPARMJ             ;print full help

BEGIN:          CMP DS:BYTE PTR [0080H],00H ;check if parameters given
                JZ NOPARM               ;if not then print full help

;READ PARAMETERS FROM THE COMMAND TAIL
HAYPRM:         MOV SI,81H              ;start of command tail -1
                MOV CH,0                ;high byte
                MOV CL,BYTE PTR DS:[80H];get parameter length
                CMP CL,0                ;check if zero
                JZ ESENTER              ;if yes then print brief help
                CLD                     ;upwards
                INC SI                  ;point to the command tail start
NDATO:          DEC CL                  ;decrement counter
                LODSB                   ;get character
                CMP AL,' '              ;is it a space ?
                JZ NDATO                ;if yes then skip it
                CMP AL,'/'              ;is it a slash ?
                JZ NDATO                ;if yes then skip it
                CMP AL,0DH              ;is ENTER ?
                JZ ESENTER              ;if yes -> ESENTER
                CMP AL,'1'              ;is it a '1'
                JZ ESUNO                ;if yes then set 03BCH
                CMP AL,'2'              ;is it a '2'
                JZ ESDOS                ;if yes then set 0378H
                CMP AL,'3'              ;is it a '3'
                JZ ESTRES               ;if yes then set 0278H
                JMP NOPARM              ;if none of above then print full help
CONT1:          DEC CL                  ;decrement counter
                LODSB                   ;get next chr
                CMP AL,' '              ;if it's not a space
                JNZ ESENTER             ;then print brief help
NDATO1:         DEC CL                  ;decrement counter
                LODSB                   ;get next chr
                CMP AL,' '              ;is it a space ?
                JZ NDATO1               ;skip adicional spaces
                CMP AL,0DH              ;is it enter ?
                JZ ESENTER              ;if yes then print brief help
                MOV BX,CS               ;make ES equal CS
                MOV ES,BX               ;by means of BX
                MOV DI,OFFSET PATHBUF   ;start of the path buffer
                DEC CX                  ;decrement counter
                STOSB                   ;store byte
                REP MOVSB               ;till the end of command is reached
                MOV AL,0                ;the ASCIIZ end marker
                STOSB                   ;is stored in bufer

;SCAN THE PATH BUFFER FOR A PERIOD
                MOV SI,OFFSET PATHBUF   ;start of path buffer
NDATA:          LODSB                   ;get byte
                CMP AL,0                ;is the end ?
                JZ FIN1                 ;jump if yes
                CMP AL,'.'              ;is it a period ?
                JZ FIN2                 ;jump if yes
                JMP NDATA               ;repeat

;ADD THE .P EXTENSION IF NO ONE IS GIVEN
FIN1:           DEC SI                  ;point to end marker
                MOV AL,'.'              ;a period in AL
                MOV [SI],AL             ;replace the 0 with a .
                INC SI                  ;increment pointer
                MOV AL,'P'              ;a 'P' in AL
                MOV [SI],AL             ;put it in place
                INC SI                  ;increment pointer
                MOV AL,' '              ;two spaces
                MOV [SI],AL             ;are added
                INC SI
                MOV AL,' '
                MOV [SI],AL
                INC SI
                MOV AL,0                ;a new end marker
                MOV [SI],AL             ;is placed as the last byte

;SCAN FOR THE '.' ADD THREE BYTES AND PLACE THE END MARKER
FIN2:           MOV DI,OFFSET PATHBUF   ;start of path buffer
                MOV AL,'.'              ;a period
LAZO2:          SCASB                   ;scan for it
                JNZ LAZO2               ;jump back if not found
                ADD DI,3                ;skip over three bytes
                MOV AL,0                ;the end marker
                STOSB                   ;put in place

;OPEN THE INPUT FILE
                MOV AH,3DH              ;Open a file
                MOV AL,00H              ;read only access
                MOV DX,OFFSET PATHBUF   ;ASCIIZ string with filename
                INT 21H                 ;DOS
                JC COFERR               ;jump if error

;READ THE FILE INTO BUFFER AND GET ITS LENGTH
                MOV BX,AX               ;pass the file handle to BX
                MOV AH,3FH              ;Read from file
                MOV CX,0FFFFH           ;the whole file lengh
                MOV DX,OFFSET BUFFER1   ;buffer to hold the file
                INT 21H                 ;DOS

;ADD THE ZX FILENAME, SEND DATA TO ZX81 AND RETURN TO DOS
                MOV SI,OFFSET BUFFER    ;file buffer begin
                MOV CX,AX               ;add AX to the length
                ADD CX,14               ;to hold the ZX file name
                CALL SAVE1500           ;save the file
                INT 20H                 ;return to DOS

;SET THE PORT ADDRES
ESUNOJ:         MOV WORD PTR [BASE],03BCH ;hercules LPT port
                JMP CONT1
ESDOSJ:         MOV WORD PTR [BASE],0378H ;LPT1
                JMP CONT1
ESTRESJ:        MOV WORD PTR [BASE],0278H ;LPT2
                JMP CONT1

;DISPLAY HELP MESSAGE AND QUIT
ESENTERJ:       MOV DX,OFFSET HELPM     ;help message string
CONT2:          MOV AH,9                ;Print string
                INT 21H                 ;DOS
                INT 20H                 ;return to DOS

;CAN'T OPEN INPUT FILE ERROR
COFERR:         MOV DX,OFFSET COFERRM   ;error message
                JMP CONT2               ;print and exit

;PRINT MESSAGES WHEN NO PARAMETERS ARE ENTERED
NOPARMJ:        MOV DX,OFFSET NOPARMM1  ;"SAVE1500 V1.0 ...."
                MOV AH,9                ;Print string
                INT 21H                 ;DOS
                MOV DX,OFFSET HELPM     ;"Usage : ...."
                MOV AH,09H              ;Print string
                INT 21H                 ;DOS
                MOV DX,OFFSET NOPARMM2  ;"1-> 03BCH ...."
                JMP CONT2               ;print and exit

;SAVE CX BYTES FROM [SI] IN TS1500 PROTOCOL TO LPT1
;WAIT ABOUT 3.3 SEC
SAVE1500:       CLI                     ;no interrupts allowed
                PUSH CX                 ;save program length
                MOV CX,60               ;54.85 mS * 60 = 3.29 S
INITDEL:        MOV WORD PTR [LEN16],0FFFFH ;65535 * .837 uS = 54.85 mS
                CALL WAIT16             ;time delay
                LOOP INITDEL            ;repeat 60 times
                POP CX                  ;retrieve program length

;SAVE CX BYTES TO THE TS1500
                CLD                     ;upwards
NBYTE:          LODSB                   ;byte into AL
                MOV BL,AL               ;move to BL
                STC                     ;set the 'marker'
NBIT:           RCL BL,1                ;rotate 'marker' in
                LAHF                    ;save flags 'cause RCL doesn't test ZF
                OR BL,BL                ;8 bits done ?
                JZ BYTEFIN              ;jump if yes
                SAHF                    ;retrieve flags
                SBB AH,AH               ;AH = 00 or AH = FF
                AND AH,05H              ;AH = 00 or AH = 05
                ADD AH,04H              ;AH = 04 or AH = 09
                MOV DX,WORD PTR [BASE]  ;get the port address
NPULSE:         MOV AL,01H              ;set D0 to high
                OUT DX,AL               ;output to the port
                MOV WORD PTR [LEN16],DELAY1 ;time delay #1
                CALL WAIT16             ;
                MOV AL,00H              ;reset D0 to low
                OUT DX,AL               ;output to the port
                MOV WORD PTR [LEN16],DELAY2 ;time delay #2
                CALL WAIT16             ;
                DEC AH                  ;decrement pulse count
                JNZ NPULSE              ;repeat until AH = 0
                MOV WORD PTR [LEN16],DELAY3 ;time delay #3
                CALL WAIT16             ;
                IN AL,60H               ;keyboard controller
                CMP AL,39H              ;is a space ?
                JZ BREAK                ;jump if yes
                JMP NBIT                ;process next bit
BYTEFIN:        LOOP NBYTE              ;process next byte
BREAK:          RET                     ;ret


;uP SPEED INDEPENDENT TIME DELAY
;delay = [LENL]+256*[lenh]*.837 uS   or..
;delay = [LEN16]*.837 uS

WAIT16:         MOV AL,0B2H             ;cnt2,b0 b7 then b8 b15,one shot,bin
                OUT 43H,AL              ;8253 ctl reg
                MOV AL,BYTE PTR [LENL]  ;get time from variable (l)
                OUT 42H,AL              ;8253 cnt2 data reg
                MOV AL,BYTE PTR [LENH]  ;get time from variable (h)
                OUT 42H,AL              ;8253 cnt2 data reg
                IN AL,61H               ;trigers monostable
                MOV BYTE PTR [KT],AL    ;settng 8042 bit 0
                OR AL,01H               ;port B
                OUT 61H,AL              ;and resetting it later
                MOV AL,BYTE PTR [KT]
                OUT 61H,AL
WAIT161:        IN AL,61H               ;checks 8042 bit 5 port B
                TEST AL,20H             ;it sets when the monostable
                JZ WAIT161              ;times out
                RET                     ;ret

DELAY1          EQU 165                 ;165 * .837 uS = 138 uS
DELAY2          EQU 165                 ;165 * .837 uS = 138 uS
DELAY3          EQU 1650                ;1650 * .837 uS = 1.38 mS
LEN16           LABEL WORD              ;16 bit delays
LENL:           DB 00H                  ;8 bit delays (l)
LENH:           DB 00H                  ;8 bit delays (h)
KT:             DB 00H                  ;auxiliary for monostable trigger
BASE            DW 0000H                ;LPT base port address

NOPARMM1:       DB 0DH,0AH,'SAVE1500 V1.0 Sends .P files to a TS1500 or ZX81'
                DB        ' through the PC parallel port.'
                DB 0DH,0AH,'By Luis C. Grosso. (Oct 12 1998)',0DH,0AH,'$'
HELPM:          DB 0DH,0AH,'Usage : SAVE1500 1|2|3 filename[.P]$'
NOPARMM2:       DB 0DH,0AH,'1-> 03BCH  2-> 0378H  3-> 0278H',0DH,0AH,'$'
COFERRM:        DB 0DH,0AH,'CAN',27H,'T OPEN INPUT FILE$'
PATHBUF:        DB 64 DUP (0)           ;full pathname buffer
BUFFER          DB 10H,28H,11H,00H,31H,1BH,28H,1BH ;(C) L.C.
                DB 2CH,37H,34H,38H,38H,0B4H        ;GROSSO in sinclair code
BUFFER1:        NOP                                ;program buffer
CSEG            ENDS
                END PRINCIPIO

;Beg your pardon for my poor English and for the unneatness of this program.
;I hope you find it useful.

;                                       Luis C. Grosso
;                                       Callao 3869  2000 Rosario
;                                       Argentina
